import clojure.lang.*;
import java.util.concurrent.*;

public class Account  {
  private Ref balance;
  
  public Account(final int initialBalance) throws Exception { 
    balance = new Ref(initialBalance); 
  }
  
  public void deposit(final int amount) throws Exception {
    LockingTransaction.runInTransaction(new Callable<Void>() {
      public Void call() {
        if (amount > 0) balance.set(getBalance() + amount); 
        System.out.println("Messages like this are not good, deposited " + amount);
        return null;        
      }
    });
    
  }
  
  public void withdraw(final int amount) throws Exception {
    LockingTransaction.runInTransaction(new Callable<Void>() {
      public Void call() {
        if(amount > 0 && getBalance() >= amount) 
        {
          balance.set(getBalance() - amount); 
        } else {
          throw new RuntimeException("not enough money!");
        }
        return null;
      }
    });
    
  }

  public int getBalance() { return (Integer) (balance.deref()); }
}